#!/usr/bin python

import sys
import argparse
import tempfile

# This script takes the full nobloom reverse compliment added (and preferably sorted) male and female jelly dump files, this iteratively compares the male 
# kmers to dictionaries of female kmers + revcomps as well as there coverages, if the male kmer is in the female hash (of kmers + revcomps) it prints out
# these value to the output printing kmer, malecoverage and female coverage. If by the end there are male kmers not found in the female hash it will print
# these to the table as: kmer, malecov and O. These are amle unique kmers.

# To get female unique kmers reverse this process so female kmers compared to male hashes, and then the last set of kmer, femalecov and O will be the
# female unique. Append these last kmers to the Male output file of shared and male unique

parser=argparse.ArgumentParser(description='''make Table of coverages (both male and female)
    -m male
    -f female
    -g memory
    -o output
    -l logfile''')
parser.add_argument('-m', '--male', type=str, required=True, help="Provide a male Jelly_dump file")
parser.add_argument('-f', '--female', type=str, required=True, help="Provide a female Jelly_dump file")
parser.add_argument('-g', '--memory', type=float, required=True, help="Provide a memory cutoff in GB")
parser.add_argument('-o', '--output', action='store', help="Directs the output to a name of your choice")
parser.add_argument('-l', '--logfile', action='store', help="Directs progress to a logfile with name of your choice")
args = parser.parse_args()

#make empty dictionary
kmers = {}
kmers1 = []
kmers2 = []
male_coverages1 = []
male_coverages2 = []
linecount = 0
prog_count = 0
Iteration_count = 0
memory = 0

#read first (female) set of kmers (and reverse compliments) into dictionary (like perl hash) 
with open(args.logfile, 'w') as log_file:
	with open(args.output, 'w') as output_file:
		print >>output_file, 'Kmer', 'MaleCoverage', 'FemaleCoverage'
	        with open(args.female, 'r') as f_file:
	                for line in f_file:
	                        line = line.rstrip('\n').rstrip('\t').split(' ')
	                        if memory < args.memory:
	                                kmers[line[0]] = line[2];
					kmers[line[1]] = line[2];
	                                memory = sys.getsizeof(kmers)
	                                memory = float(memory / 1000000000.0)
	                                linecount = linecount + 1
	                                if linecount % 1000000 == 0:
	                                        print >>log_file, "read file", linecount
	                                        print >>log_file, "memory", memory, '\n',
	                        elif memory > args.memory:
	                                kmers[line[0]] = line[2]; #not to loose line
					kmers[line[1]] = line[2];
					print "foo"
	                                Iteration_count = Iteration_count + 1
#					print kmers
	                                #check if male kmer (or female for female biased reads) not in female (or male) kmer dict
	                                if Iteration_count == 1 and Iteration_count % 2 != 0:
	                                        for line in open(args.male, 'r'):
	                                                prog_count = prog_count + 1
	                                                m = line.rstrip('\n').split(' ') #read in male kmers	
	                                                if m[0] not in kmers:	#if not in hash add male kmer + cov to lists
	                                                        kmers1.append(m[0])
								male_coverages1.append(m[2])
							elif m[0] in kmers:	#if in hash then print to outfile
#								print >>output_file, "yoo"
								# use element to get dict count 
								coverage = kmers.get(m[0])
								print >>output_file, m[0], m[2], coverage
	                                                if prog_count % 1000000 == 0:
	                                                        print >>log_file, "Kmer check", Iteration_count, prog_count
	                                                        print >>log_file, "kmers1 length", len(kmers1)

	                                elif Iteration_count > 1 and Iteration_count % 2 == 0:
	                                        print "boo"
	                                        while len(kmers1) > 0:
	                                                element = kmers1[-1]
							element2 = male_coverages1[-1]
	                                                prog_count = prog_count + 1
	                                                if element not in kmers:
	                                                        kmers2.append(element)
								male_coverages2.append(element2)
							elif element in kmers:
								coverage = kmers.get(element)
								print >>output_file, element, element2, coverage
	                                                if prog_count % 1000000 == 0:
	                                                        print >>log_file, "Kmer list check", Iteration_count, prog_count
	                                                        print >>log_file, "kmers2 length", len(kmers2)
	                                                del kmers1[-1]
							del male_coverages1[-1]
	                                        kmers1 = []
	                                elif Iteration_count > 1 and Iteration_count % 2 != 0:
	                                        print "goo"
	                                        while len(kmers2) > 0:
	                                                element = kmers2[-1]
							element2 = male_coverages2[-1]
	                                                prog_count = prog_count + 1
	                                                if element not in kmers:
	                                                        kmers1.append(element)
								male_coverages1.append(element2)
                                                        elif element in kmers:
                                                                coverage = kmers.get(element)
                                                                print >>output_file, element, element2, coverage
	                                                if prog_count % 1000000 == 0:
	                                                        print >>log_file, "Kmer list check", Iteration_count, prog_count
	                                                        print >>log_file, "kmers1 length", len(kmers1)
	                                                del kmers2[-1]
							del male_coverages2[-1]
	                                        kmers2 = []
	                                memory = 0
	                                kmers = {}
	        #code for last chunk
	        Iteration_count = Iteration_count + 1
	        print "noo"
	        if Iteration_count > 1 and Iteration_count % 2 == 0:
	                print "soo"
	                while len(kmers1) > 0:
				element = kmers1[-1]
                                element2 = male_coverages1[-1]
                                prog_count = prog_count + 1
                                if element not in kmers:
	                                kmers2.append(element)
                                        male_coverages2.append(element2)
                                elif element in kmers:
                                        coverage = kmers.get(element)
                                        print >>output_file, element, element2, coverage
	                        if prog_count % 1000000 == 0:
	                                print >>log_file, "Kmer list check", Iteration_count, prog_count
	                                print >>log_file, "kmers2 length", len(kmers2)
	                        del kmers1[-1]
				del male_coverages1[-1]
	                kmers1 = []
	        elif Iteration_count > 1 and Iteration_count % 2 != 0:
	                print "woo"
	                while len(kmers2) > 0:
	                        element = kmers2[-1]
				element2 = male_coverages2[-1]
	                        prog_count = prog_count + 1
	                        if element not in kmers:
	                                kmers1.append(element)
					male_coverages1.append(element2)
				elif element in kmers:
                                        coverage = kmers.get(element)
                                        print >>output_file, element, element2, coverage
	                        if prog_count % 1000000 == 0:
	                                print >>log_file, "Kmer list check", Iteration_count, prog_count
	                                print >>log_file, "kmers1 length", len(kmers1)
	                        del kmers2[-1]
				del male_coverages2[-1]
	                kmers2 = []

		#Print left over Kmers = Male specific
	        for element, element2 in zip(kmers1, male_coverages1):
	                print >>output_file, element, element2, "0"
		for element, element2 in zip(kmers2, male_coverages2):
	                print >>output_file, element, element2, "0"

